<?php

/*
 * Created on 10.01.2020
 * HomePage: https://xentr.net
 * Copyright (c) 2019 XENTR | XenForo Add-ons - Styles -  All Rights Reserved
 */
 
namespace XENTR\HideContent\XF\BbCode\Renderer;

use XF\Entity\Post;

class Html extends XFCP_Html
{
	
    public function renderTagUrl(array $children, $option, array $tag, array $options)
    {
        $response =  parent::renderTagUrl($children, $option, $tag, $options);
		
        $entity = $options['entity'];
		/** Get options */		
		$XFOptions = \XF::app()->options();
		
		if(!$XFOptions->xtr_hide_content_enable_url){
			return $response;
		}
		
		if ($entity instanceof Post){
			/** @var \XF\Entity\Node $node */
			$nodeId = $entity->Thread->node_id;
			/**
			* Exclude nodes Option.
			*/
			$excludedNodes = $XFOptions->xtr_hide_content_excluded_node;
			/**
			* Exclude nodes to hide URLs.
			*/
			/** @var array $nodes */		
			$excludedNodes = array_map('intval', $excludedNodes);
			
			if (in_array($nodeId, $excludedNodes))
			{
				return $response;
			}
		}

		$unfurl = false;
		if ($option !== null && !is_array($option))
		{
			$options['lightbox'] = false;

			$url = $option;
			$text = $this->renderSubTree($children, $options);

			if ($text === '')
			{
				$text = $url;
			}
		}
		else if (is_array($option) && isset($option['unfurl']) && $option['unfurl'] === 'true' 
		&& !empty($options['allowUnfurl']))
		{
			$url = $this->renderSubTreePlain($children);
			$text = '';
			$unfurl = true;
		}
		else
		{
			$url = $this->renderSubTreePlain($children);
			$text = $this->prepareTextFromUrl($url);
		}

		$url = $this->getValidUrl($url);
		if (!$url)
		{
			return $text;
		}
		$url = $this->formatter->censorText($url);
		
		/** Check Links */			
        $LinkRepo = \XF::app()->repository('XENTR\HideContent:CheckLinks');
        $whiteList = $LinkRepo->checkUrl($url);
		
		/** Check whiteList and hasPermissions */			
        $visitor = \XF::visitor();
        
		/** Check whiteList and hasPermissions */			
		if (!$visitor->hasPermission('xentrHideContent', 'HideLinks') && !$whiteList && !$visitor->user_state !== 'valid')
			
        {
            return $this->templater->renderTemplate('public:xentr_hide_bb_code_tag_url');
        }
		return $response;
    } 
	
	
	
}