<?php

/*
 * Created on 08.10.2020 - Updated: 28.02.2022
 * HomePage: https://xentr.net
 * Copyright (c) 2020 XENTR | XenForo Add-ons - Styles -  All Rights Reserved
 */

namespace XENTR\HideContent\XF\Option;

use XF\Entity\Option;
use XF\Option\AbstractOption;

class Message extends AbstractOption
{
	
	/**
	 * @param array $value
	 * @param \XF\Entity\Option $option
	 *
	 * @return bool
	 */	
	
	public static function verifyOption(&$value, Option $option)
	{		
		
		if ($option->isUpdate() && !empty($value['messageEnabled']))
		{
			if (empty($value['messageURL']))
			{
				$option->error(\XF::phrase('xentr_please_enter_hidden_content_message_urls'), $option->option_id);
				return false;
			}

			if (empty($value['messageCode']))
			{
				$option->error(\XF::phrase('xentr_please_enter_hidden_content_message_codes'), $option->option_id);
				return false;
			}

			if (empty($value['messageSpoiler']))
			{
				$option->error(\XF::phrase('xentr_please_enter_hidden_content_message_spoilers'), $option->option_id);
				return false;
			}
			
			if (empty($value['messageQuote']))
			{
				$option->error(\XF::phrase('xentr_please_enter_hidden_content_message_quotes'), $option->option_id);
				return false;
			}
		}

		return true;
	}
}